if !ConVarExists("bt_SetSpeed") then
    CreateConVar("bt_SetSpeed", '4', FCVAR_NOTIFY)
end

if !ConVarExists("bt_MinTimeScale") then
    CreateConVar("bt_MinTimeScale", '0.2', FCVAR_NOTIFY)
end

if !ConVarExists("bt_physbullet") then
    CreateConVar("bt_physbullet", '1', FCVAR_NOTIFY)
end

if !ConVarExists("bt_realtimephysbullet") then
    CreateConVar("bt_realtimephysbullet", '0', FCVAR_NOTIFY)
end

if !ConVarExists("bt_bulletspeeddivider") then
    CreateConVar("bt_bulletspeeddivider", '3', FCVAR_NOTIFY)
end

if !ConVarExists("bt_bullettracer") then
    CreateConVar("bt_bullettracer", '1', FCVAR_NOTIFY)
end

if !ConVarExists("bt_bulletspeedmul") then
    CreateConVar("bt_bulletspeedmul", '1', FCVAR_NOTIFY)
end

if !ConVarExists("bt_sound") then
    CreateConVar("bt_sound", '1', FCVAR_NOTIFY)
end

if !ConVarExists("bt_soundtype") then
    CreateConVar("bt_soundtype", '1', FCVAR_NOTIFY)
end

if !ConVarExists("bt_postprocess") then
    CreateClientConVar( "bt_postprocess", 1, true, false );
end

if CLIENT then

function TimeScalePost()

if GetConVarNumber("bt_postprocess") < 1 then return end

	local TimeScale = GetConVarNumber("host_timescale")
	local pp = {}
 	 
	pp[ "$pp_colour_addr" ] 		= 0
    pp[ "$pp_colour_addg" ] 		= 0
	pp[ "$pp_colour_addb" ] 		= 0
	pp[ "$pp_colour_brightness" ] 	= math.Clamp(-1 + TimeScale, -0.2, 0)
	pp[ "$pp_colour_contrast" ] 	= 1
	pp[ "$pp_colour_colour" ] 		= math.Clamp(TimeScale, 0, 1)
	pp[ "$pp_colour_mulr" ] 		= 0
	pp[ "$pp_colour_mulg" ] 		= 0
	pp[ "$pp_colour_mulb" ] 		= 0
		 
	DrawColorModify (pp)

end

hook.Add ("RenderScreenspaceEffects", "TimeScalePost", TimeScalePost)

local function BulletTimeOption(panel)

	local BulletTimeOption = {Options = {}, CVars = {}, Label = "#Presets", MenuButton = "1", Folder = "Bullet Time Option"}
	
	BulletTimeOption.Options["#Default"] = { bt_SetSpeed =	"4",
	bt_MinTimeScale =	"0.2",
	bt_physbullet =	"1",
    bt_realtimephysbullet =	"0",
	bt_bulletspeeddivider =	"3",
	bt_bullettracer =	"1",
	bt_bulletspeedmul =	"1",
	bt_sound = "1",
	bt_soundtype = "1",
	bt_postprocess = "1"}
							
	BulletTimeOption.Options["#Physic Bullet"] = { bt_physbullet =	"1",
    bt_realtimephysbullet =	"1",
	bt_bullettracer =	"1",
	bt_bulletspeedmul =	"1"}			
	
	BulletTimeOption.Options["#Sound Type: F.E.A.R"] = { bt_soundtype = "1"}
	BulletTimeOption.Options["#Sound Type: Matrix"] = { bt_soundtype = "2"}
	
    panel:AddControl("Label", {Text = "Physic Bullet Work Only With SWEPS"})
	
	panel:AddControl("ComboBox", BulletTimeOption)
	
	panel:AddControl("CheckBox", {
	Label = "Enable Physic Bullet",
	Command = "bt_physbullet",
	})
	
	panel:AddControl("CheckBox", {
	Label = "Physic Bullet Always Work",
	Command = "bt_realtimephysbullet",
	})
	
	panel:AddControl("CheckBox", {
		Label = "Enable Bullet Tracer",
		Command = "bt_bullettracer",
	})
	
	panel:AddControl("CheckBox", {
		Label = "Enable Bullet Time Sounds",
		Command = "bt_sound",
	})
	
	panel:AddControl("CheckBox", {
		Label = "Enable Bullet Time Color Effect",
		Command = "bt_postprocess",
	})
	
	panel:AddControl("Slider", {
		Label 	= "Bullet Time Set Speed",
		Command 	= "bt_SetSpeed",
		Type 		= "Integer",
		Min 		= "0",
		Max 		= "10",
	})
	
	panel:AddControl("Slider", {
		Label 	= "Bullet Time Min TimeScale",
		Command 	= "bt_MinTimeScale",
		Type 		= "Float",
		Min 		= "0.1",
		Max 		= "1",
	})
	
    panel:AddControl("Slider", {
		Label 	= "Bullet Speed Divider",
		Command 	= "bt_bulletspeeddivider",
		Type 		= "Integer",
		Min 		= "1",
		Max 		= "100",
	})
	
	panel:AddControl("Slider", {
		Label 	= "Bullet Speed Mul",
		Command 	= "bt_bulletspeedmul",
		Type 		= "Integer",
		Min 		= "1",
		Max 		= "20",
	})
	
	panel:AddControl("Label", {Text = "By LeErOy NeWmAn and Teta_Bonita"})
end

function BulletTimeAddOption()
	spawnmenu.AddToolMenuOption("Options", "Bullet Time Option", "LeErOy`s Bullet Time", "LeErOy`s Bullet Time", "", "", BulletTimeOption)
end
hook.Add("PopulateToolMenu", "BulletTimeAddOption", BulletTimeAddOption)


end

local Meta = FindMetaTable( "Entity" )

print( ":: Bullet Time by LeErOy NeWmAn" )
print( ":: Phys Bullet by TeTa_Bonita" )

if !Meta then
	return
end

if !Meta.FireBulletsOld then
	Meta.FireBulletsOld = Meta.FireBullets
end

Meta.FireBullets = function( self, b )

	if GetConVarNumber("bt_realtimephysbullet") < 1 and !self.BulletTime or GetConVarNumber("bt_physbullet") <= 0 then
		self:FireBulletsOld( b )
		return
	end

	for i = 1, b.Num do

		local rand = Vector( math.Rand( -b.Spread.x, b.Spread.x ), math.Rand( -b.Spread.y, b.Spread.y ), math.Rand( -b.Spread.y, b.Spread.y ) )
		local newdir = b.Dir + rand
	
	    local tBullet = {}
		tBullet.Force	= b.Damage / 2
	    tBullet.Damage	= b.Damage
	    tBullet.Spread  = Vector( 0, 0, 0 )
	    tBullet.Tracer = 0
	    tBullet.Num = 1
		tBullet.Callback = b.Callback
	
	    local tTrace = {} 
	    tTrace.filter = filter or {self, tBullet}
	    tTrace.mask = mask
	
	    if SERVER then
		local Bullet = ents.Create( "bullet_new" )
		
		Bullet:SetPos( b.Src + ( newdir ) )
		Bullet:SetAngles( newdir:Angle( ) )
		Bullet:SetOwner(self)
        Bullet:SetPhysicsAttacker(self)		
		Bullet.Dir = newdir
		Bullet.Owner = self
		Bullet.Energy = b.Damage / 5
		Bullet:SetVar("Bullet",tBullet)
		Bullet:SetVar("BulletTrace",tTrace)
		Bullet:Spawn( )
		Bullet:Activate()
		end
		
	end

end

if (SERVER) then 


function BtThink()
    local TimeScale = GetConVarNumber("host_timescale")
    for k, v in pairs(player.GetAll()) do
	if !v:IsAdmin() then return end
        if TimeScale >= GetConVarNumber("bt_MinTimeScale") and v.BulletTime == true then
            game.ConsoleCommand ("host_timescale ".. math.Approach(TimeScale, GetConVarNumber("bt_MinTimeScale"), FrameTime() * GetConVarNumber("bt_SetSpeed")) .."\n")
        elseif TimeScale <= 1 and v.BulletTime == false then
            game.ConsoleCommand ("host_timescale ".. math.Approach(TimeScale, 1, FrameTime() * GetConVarNumber("bt_SetSpeed")) .."\n")
        end
    end
end
hook.Add( "Think", "BtThink", BtThink )

function BulletTimeOn( ply )
    ply.BulletTime = true
    ply.LastTimeScale = GetConVarNumber("host_timescale")
    if GetConVarNumber("bt_sound") > 0 then
        if GetConVarNumber("bt_soundtype") <= 1 then
            ply:EmitSound(Sound("lee/bullettime1_on.wav"))
        elseif GetConVarNumber("bt_soundtype") >= 2 then
            ply:EmitSound(Sound("lee/bullettime2_on.wav"))
        end
    end
end
concommand.Add( "+bullettime", BulletTimeOn );

function BulletTimeOff( ply )
    ply.BulletTime = false
    if GetConVarNumber("bt_sound") > 0 then
        if GetConVarNumber("bt_soundtype") <= 1 then
            ply:EmitSound(Sound("lee/bullettime1_off.wav"))
        elseif GetConVarNumber("bt_soundtype") >= 2 then
            ply:EmitSound(Sound("lee/bullettime2_off.wav"))
        end
    end
end
concommand.Add( "-bullettime", BulletTimeOff );

end
